/*
*	 -. 2000.
*	 -   
*	   OlhaFullFax.dll.
*
*     -   "" ALDERIO.CPP
*/

#include <windows.h>
#include <stdio.h>

#include "alder.h"
#include "aldererr.h"

//   "".   ,  
//    BIN   .
DWORD	AlderBoardType;
//  
DWORD	BoardHandle;
//     
DWORD   AlderLine=0;

//  
HANDLE	hProcess;
//        REALTIME_PRIORITY_CLASS
//   ,   Windows    
//   .     
//        .
DWORD	PriorityClass;

//   -   IRQ 
DWORD	AlderBasePort= 0x23C, AlderIrq= 11;
//  /  (18 -  )
DWORD	HookLevel= 4;
//   (100 -  )
DWORD   RingLevel= 2;
//  
HANDLE	hcDrv= INVALID_HANDLE_VALUE;

//   .
//    (NT  Windows95/98)
//        
bool OpenDriver()
{	OSVERSIONINFO OsVer;
	char DriverName[128];

	OsVer.dwOSVersionInfoSize= sizeof(OSVERSIONINFO);
	GetVersionEx( &OsVer);
	switch( OsVer.dwPlatformId)
	{	case VER_PLATFORM_WIN32_WINDOWS:
			//   Windows 95
			//      ,
			//    ,   
			//    ""  
			// .
			DeleteFile("\\\\.\\ALDER.VXD");
			//  ,      !
			lstrcpy( DriverName, "\\\\.\\ALDER.VXD");
			break;
		case VER_PLATFORM_WIN32_NT:
			//   Windows NT 4.0
			//  ,      
			// !
			lstrcpy( DriverName, "\\\\.\\ALDER");
			break;
		default:
			printf( "Error! Unknown OS version\n");
			return false;
	}
	//   
	if(( hcDrv= CreateFile( DriverName,
							GENERIC_READ | GENERIC_WRITE,
							0,
							NULL,
							OPEN_EXISTING,
							FILE_ATTRIBUTE_NORMAL,
							NULL))== INVALID_HANDLE_VALUE)
	{	printf( "Open ALDER driver error. System error code: %d\n", GetLastError());
		return false;
	}
	return true;
}

//   
void CloseDriver()
{	if( hcDrv!= INVALID_HANDLE_VALUE)
	{	CloseHandle( hcDrv);
		hcDrv= INVALID_HANDLE_VALUE;
	}
}

//          -,
//      ""  .
bool GetAndShowBoardType()
{	DWORD		OutParams[5], Readed;	

	//     
	if( DeviceIoControl( hcDrv, drvAlderGetBoardType,
						&AlderBasePort, sizeof(DWORD),
						OutParams, sizeof(DWORD)*5,
						&Readed, NULL)== 0)
	{	printf( "GetAndShowBoardType. DeviceIoControl error. System error code: %d\n", GetLastError());
		return false;
	}
	if( OutParams[0]== AlderNoError)
	{	//    
		AlderBoardType= OutParams[1];
		switch( AlderBoardType)
		{	case Alder24aBoard:
				printf( "GetAndShowBoardType. Alder24a board found.\n");
				break;
			case Alder24amBoard:
				printf( "GetAndShowBoardType. Alder24am board found.\n");
				break;
			case Alder22aBoard:
				printf( "GetAndShowBoardType. Alder22a board found.\n");
				if( AlderLine> 1)
				{	printf( "Error! Uncorrect line number!\n");
					return false;
				}
				break;
			case Alder21aBoard:
				printf( "GetAndShowBoardType. Alder21a board found.\n");
				if( AlderLine> 0)
				{	printf( "Error! Uncorrect line number!\n");
					return false;
				}
				break;
			default:
				printf( "GetAndShowBoardType. Error! Alder board not found!\n");
				return false;
		}
		return true;
	}
	printf( "Driver error: %04X\n", OutParams[0]);
	return false;
}

//    .
//  OlhaFullFax      ,  4.3 !!!
void GetAndShowDriverVersion()
{	DWORD OutParams[3], Readed;

	if( DeviceIoControl( hcDrv, drvAlderGetVersion,
			             NULL, 0,
						 OutParams, sizeof(DWORD)*3,
						 &Readed, NULL)== 0)
		printf( "GetAndShowDriverVersion. DeviceIoControl error. System error code: %d\n", GetLastError());
	else
		printf( "GetAndShowDriverVersion. Driver Version - %d.%d.%d\n", OutParams[0], OutParams[1], OutParams[2]);
}

//   -    .
void SetPlayer()
{	DWORD Readed, DrvError;

    if( DeviceIoControl( hcDrv, drvAlderSetPlayer,
						 &BoardHandle, sizeof(DWORD),
						 &DrvError, sizeof(DWORD),
						 &Readed, NULL)== 0)
		printf( "SetPlayer. DeviceIoControl error. System error code: %d\n", GetLastError());
	else
	{	if( DrvError!= AlderNoError)
			printf( "SetPlayer. Driver error: %04X\n", DrvError);
	}
}

//  /  .
void SetRaw( bool OperType)
{   DWORD InParams[3], Readed, DrvError;

	//    !
	InParams[0]= BoardHandle;
	InParams[1]= AlderLine;
	if( OperType== true)
		InParams[2]= 1;
	else
		InParams[2]= 0;
    if( DeviceIoControl( hcDrv, drvAlderLineSetRaw,
						 InParams, sizeof(DWORD)*3,
						 &DrvError, sizeof(DWORD),
						 &Readed, NULL)== 0)
		printf( "SetRaw. DeviceIoControl error. System error code: %d\n", GetLastError());
	else
	{	if( DrvError!= AlderNoError)
			printf( "SetRaw. Driver error: %04X\n", DrvError);
	}
}

//     
//      Volume
void SetRawVolume( DWORD Volume)
{   DWORD InParams[2], Readed, DrvError;

	InParams[0]= BoardHandle;
	InParams[1]= Volume;
    if( DeviceIoControl( hcDrv, drvAlderSetRawVolume,
						 InParams, sizeof(DWORD)*2,
						 &DrvError, sizeof(DWORD),
						 &Readed, NULL)== 0)
		printf( "SetRawVolume. DeviceIoControl error. System error code: %d\n", GetLastError());
	else
	{	if( DrvError!= AlderNoError)
			printf( "SetRawVolume. Driver error: %04X\n", DrvError);
	}
}

//     
//    /    
//      HookLevel  RingLevel. 
void SetHookLevel()
{   DWORD InParams[4], Readed, DrvError;

	InParams[0]= BoardHandle;
	InParams[1]= AlderLine;
	InParams[2]= HookLevel;
	InParams[3]= RingLevel;

    if( DeviceIoControl( hcDrv, drvAlderSetPhoneParams,
						 InParams, sizeof(DWORD)*4,
						 &DrvError, sizeof(DWORD),
						 &Readed, NULL)== 0)
		printf( "SetHookLevel. DeviceIoControl error. System error code: %d\n", GetLastError());
	else
	{	if( DrvError!= AlderNoError)
			printf( "SetHookLevel. Driver error: %04X\n", DrvError);
	}
}

//    "".
bool OpenBoard()
{	
	DWORD		InParams[3], OutParams[4];
	HANDLE		lh;
	HGLOBAL		MemBase;
	PWORD       DataPtr;
	DWORD		FileSize, Readed, DrvError;
	char		LoaderName[32];

	//  
	if( OpenDriver()== false)
		return false;
	//     
	if( GetAndShowBoardType()== false)
	{	CloseDriver();
		return false;
	}
	//     
	GetAndShowDriverVersion();
	//       
	//   
	switch( AlderBoardType)
	{	case Alder24aBoard:
			lstrcpy( LoaderName, "ALDR24A.BIN");
			break;
		case Alder24amBoard:
			lstrcpy( LoaderName, "ALDR24AM.BIN");
			break;
		case Alder22aBoard:
			lstrcpy( LoaderName, "ALDR22A.BIN");
			break;
		case Alder21aBoard:
			lstrcpy( LoaderName, "ALDR21A.BIN");
			break;
		default:
			lstrcpy( LoaderName, "ALDR24A.BIN");
			break;
	}
	if(( lh= CreateFile( LoaderName, GENERIC_READ, 0, NULL,
  						OPEN_EXISTING, 0, NULL))== INVALID_HANDLE_VALUE)
	{	CloseDriver();
		printf( "OpenBoard. Loder file \'%s\' not found\n", LoaderName);
		return false;
	}
	FileSize= GetFileSize( lh, NULL);
	if(( MemBase= GlobalAlloc( GMEM_FIXED, FileSize))== NULL)
	{	CloseHandle(lh);
		CloseDriver();
		printf( "OpenBoard. Memory allocation error\n");
		return false;
	}
	DataPtr= (PWORD)MemBase;
	if( ReadFile( lh, DataPtr, FileSize, &Readed, NULL)== FALSE)
	{	CloseHandle(lh);
		GlobalFree( MemBase);
		CloseDriver();
		printf( "OpenBoard. Read file \'%s\' error\n", LoaderName);
		return false;
	}
	CloseHandle(lh);

	//    
	InParams[0]= (DWORD) AlderBasePort;
	InParams[1]= (DWORD) DataPtr;
	InParams[2]= FileSize;

	if( DeviceIoControl( hcDrv, drvAlderOpenBoard,
  						 InParams, sizeof(DWORD)*3,
  						 OutParams, sizeof(DWORD)*4,
  						 &Readed, NULL)== 0)
	{	GlobalFree( MemBase);
		CloseDriver();
		printf( "OpenBoard. DeviceIoControl error. System error code: %d\n", GetLastError());
		return false;
	}
	if( OutParams[0]!= AlderNoError)
	{	GlobalFree( MemBase);
		CloseDriver();
		printf( "OpenBoard. Driver error: %04X\n", OutParams[0]);
		return false;
	}
	BoardHandle= OutParams[1];
	printf( "OpenBoard. Board factory number: %04X. Loader version: %d.\n", 
			 OutParams[2], OutParams[3]);
	GlobalFree( MemBase);
	
	//     
	InParams[0]=AlderIrq;
	if( DeviceIoControl( hcDrv, drvAlderStartBoards,
     					&AlderIrq, sizeof(DWORD),
						&DrvError, sizeof(DWORD),
 						&Readed, NULL)== 0)
	{	CloseDriver();
		printf( "StartBoard. DeviceIoControl error. System error code: %d\n", GetLastError());
		return false;
	}
	//     
	SetPlayer();
	SetRawVolume( 6);
	SetHookLevel();

	//   
	hProcess= GetCurrentProcess();
	PriorityClass= GetPriorityClass( hProcess);
	SetPriorityClass( hProcess, REALTIME_PRIORITY_CLASS);
	return true;
}

//   
void CloseBoard()
{	DWORD		Readed, DrvError;

	//     
	DeviceIoControl( hcDrv, drvAlderStopBoards,
  					 NULL, 0,
  					 &DrvError, sizeof(DWORD),
  					 &Readed, NULL);
	//  
	DeviceIoControl( hcDrv, drvAlderCloseBoard,
  					 &BoardHandle, sizeof(DWORD),
  					 &DrvError, sizeof(DWORD),
  					 &Readed, NULL);
	CloseDriver();
}

//       
//      HookOn
bool SetHook( bool HookOn)
{   DWORD InParams[3], Readed, DrvError;

	InParams[0]= BoardHandle;
	InParams[1]= AlderLine;
	if( HookOn== false)
		InParams[2]= 0;
	else
		InParams[2]= 1;

    if( DeviceIoControl( hcDrv, drvAlderSetHookMode,
						 InParams, sizeof(DWORD)*3,
						 &DrvError, sizeof(DWORD),
						 &Readed, NULL)== 0)
	{	printf( "SetHook. DeviceIoControl error. System error code: %d\n", GetLastError());
		return false;
	}
	else
	{	if( DrvError!= AlderNoError)
		{	printf( "SetHook. Driver error: %04X\n", DrvError);
			return false;
		}
	}
	Sleep(1000); //   
	return true;
}

//     .
bool GetLineStatus( LineStatus *ls)
{	DWORD InParams[3], Readed, DrvError;

	InParams[0]= BoardHandle;
	InParams[1]= AlderLine;
	InParams[2]= (DWORD)ls;
	if( DeviceIoControl( hcDrv, drvAlderGetLineStatus,
						 InParams, sizeof(DWORD)*3,
						 &DrvError, sizeof(DWORD),
						 &Readed, NULL)== 0)
	{	printf( "GetLineStatus. DeviceIoControl error. System error code: %d\n", GetLastError());
		return false;
	}
	else
	{	if( DrvError!= AlderNoError)
		{	printf( "GetLineStatus. Driver error: %04X\n", DrvError);
			return false;
		}
	}
	return true;
}

