/*
*    . 2000.
*   -   OlhaFullFax
*  :     ""
*    CONSOLE.CPP
*/
#include <windows.h>
#include <stdio.h>
#include <conio.h>

#include "alder.h"
#include "aldererr.h"
#include "utils.h"

#include "OlhaFullFax.h"

#pragma comment( lib, "OlhaFullFax.lib" )

//  /  
bool	Sound= true;

//   BMP    
char	FaxFileName[256];

//  
extern	HANDLE	hcDrv;
//   -  IRQ  ""
extern	DWORD	AlderBasePort, AlderIrq;
//  / 
extern	DWORD	HookLevel;
//   ""
extern	DWORD	BoardHandle;
//    "" (   0)
//     
extern	DWORD	AlderLine;
//     (DIALTONE)
extern	bool	DialTone;
//     
extern	char	DialNumber[64];

//  /  
//     
void	SetRaw( bool OperType);
//    ""
bool	OpenBoard();
//    ""
void	CloseBoard();
//      
//   
bool	SetConnect();
//    BUSY ()
bool	CheckBusy();

void SetHookLevel();
bool WaitFaxCarrier( int TimeOutInSec);

//      OlhaFullFax
char UserFaxKey[32];
//    
AlderTransmitFaxData afd;

//    
bool BeginFaxTransmission()
{	
	//     AlderTransmitFaxData
	//  
	afd.cbSize= sizeof( AlderTransmitFaxData);
	//  
	lstrcpy( afd.pszKey, UserFaxKey);
	//   .     .
	afd.hcDrv= hcDrv;
	//  
    afd.dwBoardHandle= BoardHandle;
	//       ()
	afd.dwLine= AlderLine;
	//    -
	afd.EndFaxTransmitFunc= NULL;
	//       
	afd.dwUserMessNumberStop= 0;
	return AlderOpenFaxTransmission( &afd);

}

//   
void EndFaxTransmission()
{	
	AlderCloseFaxTransmission( &afd);
	SetRaw( false);
}

//  /  
//     
void SetPhone()
{	Sound=!Sound;
	SetRaw( Sound);
}

//-------------------------------------------
char	Rate[40]="      ";
char	StatConnect[40]="      ";
int		OldStatFax=0;
int		NewStatFax;
int		OldParam;

//-------------------------------------------
//    
void PaintStat()
{
	printf("  Status: %s  BaudRate: %s\n", StatConnect, Rate);
}

//--------------------------------------------
int ShowStat()
{	
	int param;

	NewStatFax= AlderGetTransmissionStatus( &afd,&param);
	if(( OldParam== param) && ( OldStatFax== NewStatFax)) 
		return NewStatFax;
	OldStatFax= NewStatFax;
	OldParam= param;

	switch( NewStatFax)
	{	
		case FaxTransmitOff:
			strcpy(StatConnect,"end of transmision\n");
            lstrcpy( Rate,"");
            break;
		case FaxTransmitConnecting:
			lstrcpy( StatConnect, "connecting\n");
			lstrcpy( Rate,"");
			break;
		case FaxTransmitTraining:
			lstrcpy( StatConnect, "fax training\n");
			switch( param)
            {	case 0:
			        lstrcpy( Rate,"2400");
					break;
				case 1:
					lstrcpy( Rate,"4800");
					break;
				case 2:
					lstrcpy( Rate,"7200");
					break;
				case 3:
					lstrcpy( Rate,"9600");
					break;
            }
            break;
		case FaxTransmitSending:
			wsprintf( StatConnect, "sending page %d\n", param+1);
			break;
	}
	PaintStat();
	return NewStatFax;
}

void ShowFinalStatus()
{
	switch( afd.dwFinalStatus)
	{	case FaxTransmitNoError:		
			printf("OK");
			break;
		case FaxTransmitSystemError:
			printf("There was a system error during transmit. GetLastError:%d\n", afd.dwSystemError);
			break;
		case FaxTransmitDriverError:			
			printf("The driver has returned a error number %04X\n",afd.dwDrvError);
			break;
		case FaxTransmitDeviceIoError:		
			printf("DeviceIOControl was finished unsuccessfully. GetLastError:%d\n",afd.dwSystemError);
			break;
		case FaxTransmitMemoryFault:			
			printf("Error at allocation of memory.\n");
			break;
		case FaxTransmitAlreadyStarted:		
			printf("The transmitter is already started.\n");
			break;
		case FaxTransmitFileReadError:
			printf("The input file is not found.\n");
			break;
		case FaxTransmitNoFaxPages:			
			printf("In an input file there are no facsimile sheets.\n");
			break;
		case FaxTransmitTooManyLines:
			printf("Too large number of a board / channel\n");
			break;
		case FaxTransmitDriverVersionFault:	
			printf("The wrong version of the driver.\n");
			break;
		case FaxTransmitFileCorrupt:
			printf("The input file is corrupted.\n");
			break;
		case FaxTransmitMustBeRun:
			printf("The transmitter should be already started.\n");
			break;
		case FaxTransmitUncorrectVersion:
			printf("Uncorrect DLL version.\n");
			break;
		default:
			printf("Unrecognized error.\n");
			break;
	}
}


//      
//        
bool GetKeys( int argc, char **argv)
{	
	int i;

	for( i= 1; i< argc; i++)
	{	strupr( argv[i]);
		//      
		if( StrCmp( argv[i], "/K:", 3)== true)
		{	lstrcpy( UserFaxKey, argv[i]+ 3);
			continue;
		}
		//   -  ""
		if( StrCmp( argv[i], "/P:", 3)== true)
		{	sscanf( argv[i]+ 3, "%X", &AlderBasePort);
			if( CheckBasePorts( AlderBasePort)== false)
			{	printf( "%s. Base port fault!\n", argv[i]);
				return false;
			}
			continue;
		}
		//  IRQ   ""
		if( StrCmp( argv[i], "/I:", 3)== true)
		{	sscanf( argv[i]+ 3, "%d", &AlderIrq);
			if( CheckIrqs( AlderIrq)== false)
			{	printf( "%s. IRQ fault!\n", argv[i]);
				return false;
			}
			continue;
		}
		//  / 
		//    , 
		//  ""      
		//   
		if( StrCmp( argv[i], "/H:", 3)== true)
		{	sscanf( argv[i]+ 3, "%d", &HookLevel);
			if(( HookLevel< 0) || ( HookLevel> 15))
			{	printf( "%s. HookLevel fault!\n", argv[i]);
				return false;
			}
			continue;
		}
		//     
		if( StrCmp( argv[i], "/T", 2)== true)
		{	DialTone= true;
			continue;
		}
		//     
		if( StrCmp( argv[i], "/P", 2)== true)
		{	DialTone= false;
			continue;
		}
		//     
		if( StrCmp( argv[i], "/L:", 3)== true)
		{	sscanf( argv[i]+ 3, "%d", &AlderLine);
			if(( AlderLine< 0) || ( AlderLine> 3))
			{	printf( "%s. Line number fault!\n", argv[i]);
				return false;
			}
			continue;
		}
		//      
		if(( StrCmp( argv[i], "/N:", 3)== true) && (DialNumber[0]== 0))
		{	sscanf( argv[i]+ 3, "%s", DialNumber);
			if( CheckDialNumber( DialNumber)== false)
			{	printf( "%s. Dial number fault!\n", argv[i]);
				return false;
			}
			continue;
		}
		//   BMP      
		if(( argv[i][0]!= '/') && ( FaxFileName[0]== 0))
		{	lstrcpy( FaxFileName, argv[i]);
			if( FileExist( FaxFileName)== false)
			{	printf( "%s. File not found!\n", argv[i]);
				return false;
			}
			continue;
		}
	}
	// -      
	if( DialNumber[0]== 0)
	{	printf( "Key \'/N:<DialNumber>\' is required!\n");
		return false;
	}
	return true;
}

//     
void PrintUsage( char *ProgName)
{	char *Ptr;

	printf( "\n\nFax transmitter for Alder board. AgatRT. 2000 \n");
	Ptr= strrchr( ProgName, '\\'); 
	if( Ptr== NULL)
		Ptr= ProgName;
	else
		Ptr++;
	printf( "Usage:\n  %s [/P:n] [/I:n] [/T|/P] </N:n> [/L:n] <FaxImageFile>\n",
		     Ptr);
	printf( " Keys:\n");
	printf( "  /K:n   User key for using OlhaFullFax\n");
	printf( "  /P:n   n - Alder board base port (23C - default)\n");
	printf( "  /I:n   n - Alder board IRQ (11 - default)\n");
	printf( "  /T     Dial phone number on tone mode (default)\n");
	printf( "  /P     Dial phone number on pulse mode\n");
	printf( "  /H:n   Hook level 0-15 (4 - default)\n");
	printf( "  /L:n   n - Alder board line for fax transmitting (0 - default)\n");
	printf( "  /N:n   n - Phone number string for dialing ( required!)\n");
	printf( "  <FaxImageFile> - file with Huffman code image (required!)\n\n");
}

void main( int argc, char **argv)
{	
	DWORD MajorVersion, MinorVersion;

	if( argc== 1)
	{	PrintUsage( argv[0]);
		return;
	}
	if( GetKeys( argc, argv)== false)
	{	PrintUsage( argv[0]);
		return;
	} 

	//      
	printf( "AlderBasePort:     %04X\n", AlderBasePort);
	printf( "AlderIrq:          %d\n", AlderIrq);
	printf( "AlderLine:         %d\n", AlderLine);
	printf( "HookLevel:         %d\n", HookLevel);
	if( DialTone== true)
		printf( "Dial in tone mode\n");
	else
		printf( "Dial in pulse mode\n");
	printf( "AlderDialNumber:   %s\n", DialNumber);
	printf( "FaxImageFile:      %s\n", FaxFileName);

	AlderGetDllVersion( &MajorVersion, &MinorVersion);
	printf( "\nOlhaFullFax version: %d.%d\n", MajorVersion, MinorVersion);

	ZeroMemory( &afd, sizeof( AlderTransmitFaxData));
	//  
	if( OpenBoard()== false) 
	{	
		PrintUsage( argv[0]);
		return;
	} 
	//   
	SetRaw( Sound);

	//      
	// BMP     
	GetTempPath( sizeof( afd.pszFaxFileName), afd.pszFaxFileName);
	GetTempFileName( afd.pszFaxFileName, "fax", 0, afd.pszFaxFileName);

	//  BMP 
	if( bmp2fax( afd.pszFaxFileName, FaxFileName))
	{	
		DeleteFile( afd.pszFaxFileName);
		printf("Wrong a BMP  file.\n");
		CloseBoard();
		return;
	}
	SetHookLevel( );
	//  
	printf( "Set connection...");
	if( SetConnect()== false)
	{	
		printf( "Error! Unable set connect!\n");
	    CloseBoard();
	    DeleteFile( afd.pszFaxFileName);
		return;
	}
	printf( "Wait Fax Carrier...");
	if( WaitFaxCarrier( 20)== false)
	{	
		printf( "Error! Unable get fax carrier!\n");
	    CloseBoard();
	    DeleteFile( afd.pszFaxFileName);
		return;
	}
	//   
	BeginFaxTransmission();
	printf("\n\n  Sending file \'%s\' from line %d\n", 
			FaxFileName, AlderLine);
	printf("\n\n  'Q' - quit,  'S' - sound on/off \n\n\n\n\n");
	do
	{	
		//    (BUSY)
		if( CheckBusy()== true)
			break;
		printf("\r");
		if( kbhit()!=0) 
		{	
			switch( getch())
			{	case 's':
				case 'S':
					SetPhone();
					break;
				case 0x1b:
				case 'q':
				case 'Q':
					//   
					EndFaxTransmission();
					break;
			}
		}
		Sleep(50);
	} while( ShowStat()!= FaxTransmitOff);
	ShowFinalStatus();
	printf("\n Wait busy signal\n");
	while(1)
	{	
		//    (BUSY)
		if( CheckBusy()== true)
			break;
		if( kbhit()!=0) 
		{	if( getch()== 0x1b)
			{	printf( "Canceled!\n\n");
				break;
			}
		}
		Sleep(50);
	} 
	CloseBoard();
	DeleteFile( afd.pszFaxFileName);
}

